<?php
/**
 * @category    Sprypay
 * @package     Sprypay_Sprypay
 * @copyright   Copyright (c) 2012 Sprypay (http://www.sprypay.ru)
 * @license     BSD
 */
class Sprypay_Sprypay_IndexController extends Mage_Core_Controller_Front_Action
{
    /**
     * Делает перенаправление на сайт Sprypay для осуществления оплаты.
     *
     * @access public
     * @return void
     */
    public function redirectAction()
    {
        $model = Mage::getModel('sprypay/payment');
        $data = $model->getRedirectFormFields();

        if (!empty($data)) {
            $this->importFromSprypayLibrary('SprypayRequestPaymentForm');

            $form = new SprypayRequestPaymentForm();
            $form->setShopId($data['shopId']);
            $form->setShopPaymentId($data['paymentId']);
            $form->setAmount($data['amount']);
            $form->setCurrency($data['currency']);
            $form->setUserEmail($data['userEmail']);
            $form->setPurpose($data['purpose']);
            $form->setLanguage($data['language']);
            echo $form->renderForm();

        } else
            $this->_redirect('checkout/cart');
    }

    /**
     * Обрабатывает оповещение об успешно проведенном платеже.
     *
     * @access public
     * @return void
     */
    public function ipnAction()
    {
        $model = Mage::getModel('sprypay/payment');
        $validationResult = $model->validateIpn($this->getRequest());
        if ($validationResult === true) {
            if ($model->updateOrderState())
                echo $model->confirmNotification();
            else
                echo "Unknown error";
        } else
            echo $validationResult;
    }

    public function cancelAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPaypalStandardQuoteId(true));
        if ($session->getLastRealOrderId()) {
            $order = Mage::getModel('sales/order')->loadByIncrementId($session->getLastRealOrderId());
            if ($order->getId()) {
                $order->cancel()->save();
            }
            Mage::helper('sprypay/checkout')->restoreQuote();
        }
        $this->_redirect('checkout/cart');
    }

    public function  successAction()
    {
        $session = Mage::getSingleton('checkout/session');
        $session->setQuoteId($session->getPaypalStandardQuoteId(true));
        Mage::getSingleton('checkout/session')->getQuote()->setIsActive(false)->save();
        $this->_redirect('checkout/onepage/success', array('_secure'=>true));
    }


    private function importFromSprypayLibrary($className)
    {
        $file = Mage::getBaseDir().DS.'lib'.DS.'sprypaylib'.DS.$className.'.php';
        if (file_exists($file))
            require_once($file);
        else
            throw new Exception('Sprypaylib: class '.$className.' not found');
    }
}
